/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */

package org.eclipse.pop.ssme;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Formal Process</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.pop.ssme.FormalProcess#getModelKind <em>Model Kind</em>}</li>
 *   <li>{@link org.eclipse.pop.ssme.FormalProcess#getModelType <em>Model Type</em>}</li>
 *   <li>{@link org.eclipse.pop.ssme.FormalProcess#getModelName <em>Model Name</em>}</li>
 * </ul>
 *
 * @see org.eclipse.pop.ssme.SsmePackage#getFormalProcess()
 * @model
 * @generated
 */
public interface FormalProcess extends TypesOrSignalsDeclaration {
	/**
	 * Returns the value of the '<em><b>Model Kind</b></em>' attribute.
	 * The literals are from the enumeration {@link org.eclipse.pop.ssme.ModelKind}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Kind</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Model Kind</em>' attribute.
	 * @see org.eclipse.pop.ssme.ModelKind
	 * @see #setModelKind(ModelKind)
	 * @see org.eclipse.pop.ssme.SsmePackage#getFormalProcess_ModelKind()
	 * @model required="true"
	 * @generated
	 */
	ModelKind getModelKind();

	/**
	 * Sets the value of the '{@link org.eclipse.pop.ssme.FormalProcess#getModelKind <em>Model Kind</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Model Kind</em>' attribute.
	 * @see org.eclipse.pop.ssme.ModelKind
	 * @see #getModelKind()
	 * @generated
	 */
	void setModelKind(ModelKind value);

	/**
	 * Returns the value of the '<em><b>Model Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Type</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Model Type</em>' containment reference.
	 * @see #setModelType(Identifier)
	 * @see org.eclipse.pop.ssme.SsmePackage#getFormalProcess_ModelType()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Identifier getModelType();

	/**
	 * Sets the value of the '{@link org.eclipse.pop.ssme.FormalProcess#getModelType <em>Model Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Model Type</em>' containment reference.
	 * @see #getModelType()
	 * @generated
	 */
	void setModelType(Identifier value);

	/**
	 * Returns the value of the '<em><b>Model Name</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Name</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Model Name</em>' containment reference.
	 * @see #setModelName(Identifier)
	 * @see org.eclipse.pop.ssme.SsmePackage#getFormalProcess_ModelName()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Identifier getModelName();

	/**
	 * Sets the value of the '{@link org.eclipse.pop.ssme.FormalProcess#getModelName <em>Model Name</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Model Name</em>' containment reference.
	 * @see #getModelName()
	 * @generated
	 */
	void setModelName(Identifier value);

} // FormalProcess
